--DBCC - Database Consistency Checker 
DBCC HELP ('?');
GO--32 

DBCC TRACEON(2588);
DBCC HELP ('?');
GO--95 

--  
DBCC TRACEON(3604);
DBCC DBINFO WITH TABLERESULTS;
DBCC PAGE ( test_database_01 , 1, 9, 3 ) WITH TABLERESULTS;

select * from sys.databases where name = 'test_database_01'

alter database test_database_01 set restricted_user with rollback immediate
exec sp_renamedb 'test_database_01', 'test_database_01_a'
exec sp_renamedb 'test_database_01_a', 'test_database_01'
alter database test_database_01 set multi_user

--  
DBCC DBREINDEX;
DBCC DBREINDEXALL( 'test_database_01' );

--    
select * from dbo.tbl_test_01

select top 10 bd.database_id
            , bd.file_id 
            , bd.page_id 
            , bd.row_count
            , bd.free_space_in_bytes
            , p.object_id
            , p.rows
  from sys.dm_os_buffer_descriptors bd
    inner join sys.allocation_units au
      on au.allocation_unit_id = bd.allocation_unit_id
    inner join sys.partitions p
      on au.container_id = p.hobt_id
  where bd.page_type = 'DATA_PAGE'
    and p.object_id = object_id ( 'dbo.tbl_test_01', 'U' )
    and bd.database_id = db_id();

DBCC TRACEON(3604);
DBCC PAGE ( 5, 1, 804, 1 ) WITH TABLERESULTS;
/*
0 - print just the page header
1 - page header plus per-row hex dumps and a dump of the page slot array (unless its a page that doesn't have one, like allocation bitmaps)
2 - page header plus whole page hex dump
3 - page header plus detailed per-row interpretation
*/

--     
DBCC FREEPROCCACHE;
DBCC FLUSHPROCINDB ( 5 );

--  
DBCC LOG ( 5 );
checkpoint;




