--DMV

/************************************
--  

      , 
        SQL Server Database Engine. 
************************************/
--     MicrosoftSQL Server. 
--     .

--   rowset  hobt.     rowset  hobt.
select * from sys.system_internals_partitions
where object_id = object_id ( 'dbo.tbl_test_01', 'U' );

--         .
--     ,       
select au.* from sys.system_internals_allocation_units au
  inner join sys.partitions p
    on au.container_id = p.partition_id
  where p.object_id = object_id ( 'dbo.tbl_test_01', 'U' );

--    rowset  hobt.
--       ,       .
select pc.* 
  from sys.system_internals_partitions p
      join sys.system_internals_partition_columns pc 
      on p.partition_id = pc.partition_id
    where p.object_id = object_id( 'dbo.tbl_test_01', 'U' );

---------------------------------------------------------

--    ( DBCC RULEOFF/RULEON )
select * from sys.dm_exec_query_transformation_stats;

select  top (0)
        name,
        promise_total,
        promised,
        built_substitute,
        succeeded
into    #Snapshot
from    sys.dm_exec_query_transformation_stats;

DBCC RULEON('GetToIdxScan');
DBCC RULEON('GetToScan');
DBCC RULEON('ProjectToComputeScalar');
DBCC RULEON ('EnforceSort');

-- Clear the snapshot
truncate table #Snapshot;
 
-- Save a snapshot of the DMV
insert  #Snapshot 
        (
        name, 
        promise_total, 
        promised, 
        built_substitute, 
        succeeded
        )
select  name, 
        promise_total,
        promised, 
        built_substitute, 
        succeeded
from    sys.dm_exec_query_transformation_stats
option  (keepfixed plan);
 
-- Query under test
-- Must use OPTION (RECOMPILE)
set statistics profile on;
select * from dbo.tbl_test_01 order by newid()
option (recompile);
set statistics profile off;
-- Results
select  QTS.name,
        promise = QTS.promised - S.promised,
        promise_value_avg = 
            case
                when QTS.promised = S.promised
                    then 0
                else
                    (QTS.promise_total - S.promise_total) /
                    (QTS.promised - S.promised)
            end,
        built = QTS.built_substitute - S.built_substitute,
        success = QTS.succeeded - S.succeeded
from    #Snapshot S
join    sys.dm_exec_query_transformation_stats QTS
        on QTS.name = S.name
where   QTS.succeeded != S.succeeded
order   by
        promise_value_avg desc
option  (keepfixed plan);


